力扣刷题23

第一题:搜索旋转排序数组

来源: https://leetcode.cn/problems/search-in-rotated-sorted-array/description/

题目:

整数数组 nums 按升序排列,数组中的值 互不相同 。

在传递给函数之前,nums 在预先未知的某个下标 k(0 <= k < nums.length)上进行了 向左旋转 ,使数组变为 [nums[k], nums[k+1], ..., nums[n-1], nums[0], nums[1], ..., nums[k-1]](下标 从 0 开始 计数)。例如, [0,1,2,4,5,6,7] 下标 3 上向左旋转后可能变为 [4,5,6,7,0,1,2] 。

给你 旋转后 的数组 nums 和一个整数 target ,如果 nums 中存在这个目标值 target ,则返回它的下标,否则返回 -1 。

你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。

python 复制代码
class Solution:
    def search(self, nums: list[int], target: int) -> int:
        left, right = 0, len(nums) - 1
        
        while left <= right:
            mid = (left + right) // 2
            if nums[mid] == target:
                return mid
            
            # 左半部分有序
            if nums[left] <= nums[mid]:
                # target 在左半部分的有序区间内
                if nums[left] <= target < nums[mid]:
                    right = mid - 1
                else:
                    left = mid + 1
            # 右半部分有序
            else:
                # target 在右半部分的有序区间内
                if nums[mid] < target <= nums[right]:
                    left = mid + 1
                else:
                    right = mid - 1
        
        return -1

这个题让我们查找target所在位置的索引,且题目中要求时间复杂度为O(logn),所以我想到的是二分法。虽然这个数组是旋转有序(比如4,5,6,1,2,3,但它的局部仍然是有序的 ,二分法的核心就是利用有序性缩小查找范围,这个场景刚好能适配。

二分法的本质是"分治"思路,就是每次把查找范围缩小一半,直到找到目标或者确定目标不存在。

核心条件是数组必须是有序的,可以是升序也可以是降序。

基本步骤:

初始化左指针left = 0,初始化右指针right = len(nums) - 1,覆盖整个数组;

循环:当覆盖范围有效,即left right,计算中间位置mid = (left + right) // 2,然后比较numsmid与target,如果相等,就是找到了目标,直接返回mid,否则分两种情况:当numsmid > target时,目标在左半部分,调整右指针right = mid - 1;当numsmid < target时,目标在右半部分,调整左指针left = mid + 1,假如循环结束后仍然没有找到答案,就返回-1。


举个例子模拟一下,以nums = 4,5,6,7,0,1,2,target = 0为例:

初始left = 0,right = 6,mid = 3,numsmid = 7 ,不等于target,numsmid > target, 0 < 7,且左半部分有序,但0不在此部分内,所以left = 4;

此时,left = 4,right = 6,mid = 5,numsmid = 1,numsmid > target,0 < 1,且 右半部分有序,但0也不在此部分内,所以right = 4;

此时left = 4,right = 4,mid = 4,numsmid = 0,numsmid == target,返回mid = 4。

与示例所给结果一致。

ok,记录完毕。


第二题:在排序数组中查找元素的第一个和最后一个位置

来源: https://leetcode.cn/problems/find-first-and-last-position-of-element-in-sorted-array/

题目:

给你一个按照非递减顺序排列的整数数组 nums,和一个目标值 target。请你找出给定目标值在数组中的开始位置和结束位置。

如果数组中不存在目标值 target,返回 [-1, -1]。

你必须设计并实现时间复杂度为 O(log n) 的算法解决此问题。

python 复制代码
from typing import List

class Solution:
    def searchRange(self, nums: List[int], target: int) -> List[int]:
        def find_left():
            left, right = 0, len(nums) - 1
            while left <= right:
                mid = (left + right) // 2
                if nums[mid] < target:
                    left = mid + 1
                else:
                    right = mid - 1
            if left < len(nums) and nums[left] == target:
                return left
            else:
                return -1

        def find_right():
            left, right = 0, len(nums) - 1
            while left <= right:
                mid = (left + right) // 2
                if nums[mid] > target:
                    right = mid - 1
                else:
                    left = mid + 1
            if right >= 0 and nums[right] == target:
                return right
            else:
                return -1

        left_pos = find_left()
        if left_pos == -1:
            return [-1, -1]
        right_pos = find_right()
        return [left_pos, right_pos]

根据题目提示,时间复杂度为O(logn),所以我想到的还是二分法。原理和上一题一样,搞定,记录完毕。

相关推荐
这个DBA有点耶4 小时前
MySQL B-tree索引并发控制优化:写密集场景的锁瓶颈与内核级解法
java·数据库·程序人生·算法·database·dba
爱读书的小胖4 小时前
Deaf Grandma:C 语言三版代码分析
算法
信奥卷王5 小时前
[GESP202503 六级] 环线(含视频)
算法
CQU_JIAKE5 小时前
10.15【A】
算法
晴天的雨.9925 小时前
【C++】模板进阶
开发语言·c++·算法
木井巳5 小时前
【动态规划】三步问题
java·算法·leetcode·动态规划·推荐算法
楚识科技5 小时前
手写 OCR 识别技术深度解析:从算法原理到政企级落地实现
算法·ocr
leobertlan14 小时前
痛苦系列 | DSP-03 跨越单位圆:Z变换与零极点分析
算法·程序员
蛋蛋的就会顺顺的14 小时前
hot100 p0——栈,贪心算法,动态规划
java·前端·javascript·算法·leetcode·力扣
开发小能手12315 小时前
答案daanC语言
数据结构·算法